(function() {
  var __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  PuppetEnterpriseConsole.Resource = (function(_super) {

    __extends(Resource, _super);

    function Resource() {
      return Resource.__super__.constructor.apply(this, arguments);
    }

    Resource.encode('title', 'properties', 'variations', 'nodeCount');

    Resource.primaryKey = 'title';

    Resource.storageKey = 'resources';

    return Resource;

  })(Batman.Model);

  PuppetEnterpriseConsole.ResourceType = (function(_super) {

    __extends(ResourceType, _super);

    function ResourceType() {
      return ResourceType.__super__.constructor.apply(this, arguments);
    }

    ResourceType.persist(Batman.RestStorage);

    ResourceType.url = "/live-management/lm/resource_types";

    ResourceType.primaryKey = 'name';

    ResourceType.encode('name');

    ResourceType.accessor('type', function() {
      return this.get('name');
    });

    ResourceType.resourceName = 'resource_type';

    return ResourceType;

  })(Batman.Model);

  PuppetEnterpriseConsole.prevent('run');

  PuppetEnterpriseConsole.ResourceType.load(function(_, types) {
    var type, _i, _len;
    for (_i = 0, _len = types.length; _i < _len; _i++) {
      type = types[_i];
      PuppetEnterpriseConsole.Resource[type.get('name')] = (function(_super) {
        var loadedSet,
          _this = this;

        __extends(_Class, _super);

        function _Class() {
          return _Class.__super__.constructor.apply(this, arguments);
        }

        _Class.resourceName = type.get('name');

        _Class.accessor('route', function() {
          return {
            type: this.constructor.resourceName,
            title: this.get('title'),
            controller: 'resources',
            action: 'details'
          };
        });

        _Class.persist(Batman.RestStorage.Filtered.ByNodeSet).after('readAll', function(_arg, next) {
          var data;
          data = _arg.data;
          _Class.set('rawData', data);
          return next();
        });

        PuppetEnterpriseConsole.on('ready', function() {
          return PuppetEnterpriseConsole.Node.observe('nodeSetID', function() {
            return _Class.invalidate();
          });
        });

        loadedSet = new Batman.Set();

        loadedSet.accessor('timeago', function() {
          Timer.get('everyMinute');
          if (this.get('timestamp') != null) {
            return jQuery.timeago(this.get('timestamp'));
          }
        });

        _Class.set('loadedForSelection', loadedSet);

        _Class.classAccessor('forSelection', {
          get: function() {
            var resources,
              _this = this;
            resources = this.get('loadedForSelection');
            if (!resources.get('state')) {
              resources.set('state', 'loading');
              resources.unset('total');
              resources.unset('variations');
              resources.unset('unique');
              resources.clear();
              this.load(function(err, nodes) {
                var now;
                resources.add.apply(resources, nodes);
                resources.set('state', 'loaded');
                now = new Date();
                resources.set('humanTime', "" + (now.toLocaleDateString()) + " at " + (now.toLocaleTimeString()));
                resources.set('timestamp', now);
                resources.set('similarity', Batman.Filters.asPercentOf(resources.variations - resources.unique, resources.total - resources.unique, true));
                return resources.set('similarityStyle', {
                  width: resources.get('similarity')
                });
              });
            }
            return resources;
          }
        });

        _Class.classAccessor('rawData', {
          set: function(k, v) {
            this.get('forSelection').set('total', v.total);
            this.get('forSelection').set('variations', v.variations);
            return this.get('forSelection').set('unique', v.resources.length);
          }
        });

        _Class.invalidate = function() {
          this.get('loaded').clear();
          this.get('loadedForSelection').clear();
          this.get('loadedForSelection').unset('state');
          this.get('loadedForSelection').unset('total');
          this.get('loadedForSelection').unset('humanTime');
          this.get('loadedForSelection').unset('timestamp');
          this.get('loadedForSelection').unset('similarity');
          this.get('loadedForSelection').unset('name');
          return this;
        };

        _Class.url = "/live-management/lm/resources/" + (type.get('name'));

        _Class.prototype.url = function() {
          return "" + this.constructor.url + "/" + (this.get('title'));
        };

        _Class.accessor('isoTimestamp', function() {
          var _ref;
          Timer.get('everyMinute');
          return (_ref = this.get('timestamp')) != null ? _ref.toISOString() : void 0;
        });

        return _Class;

      }).call(this, PuppetEnterpriseConsole.Resource);
    }
    PuppetEnterpriseConsole.allow('run');
    if (PuppetEnterpriseConsole.wantsToRun) {
      return PuppetEnterpriseConsole.run();
    }
  });

}).call(this);
