class PluginPuppetBaselineCreateBaselines < ActiveRecord::Migration
  def self.up
    create_table :node_baselines do |t|
      t.integer :node_id
      t.integer :baseline_id
      t.date    :date
    end

    add_index :node_baselines, [:node_id, :date], :unique => true

    create_table :node_group_baselines do |t|
      t.integer :node_group_id
      t.integer :baseline_id
      t.date    :date
    end

    add_index :node_group_baselines, [:node_group_id, :date], :unique => true

    create_table :baselines

    create_table :baseline_resources do |t|
      t.integer :baseline_id
      t.string :resource_type
      t.string :title
    end

    add_index :baseline_resources, [:baseline_id, :resource_type, :title]

    create_table :baseline_properties do |t|
      t.integer :baseline_resource_id
      t.string  :name
      t.string  :value
    end

    add_index :baseline_properties, :baseline_resource_id
  end

  def self.down
    drop_table :node_baselines
    drop_table :node_group_baselines
    drop_table :baselines
    drop_table :baseline_resources
    drop_table :baseline_properties
  end
end
